//
//  EODatabaseContextInspector.java
//  EOInspector
//

import com.webobjects.foundation.*;
import com.webobjects.eoaccess.*;
import com.webobjects.eocontrol.*;

public class EODatabaseContextInspector extends Inspector {

	public String bindingBaseName() {
		return "dbctxt";
	}
	
    public EODatabaseContext dc() {
        return (EODatabaseContext)object();
    }

    public NSArray allKeys() {
        return new NSArray(new Object[]{
            "database", "availableChannel", "adaptorContext", 
            "hasBusyChannels", "updateStrategy", "missingObjectGlobalIDs"});
    }

    public NSArray allActions() {
        return new NSArray(new Object[] {
            "setUpdateStrategyToUpdateWithOptimisticLocking",
            "setUpdateStrategyToUpdateWithPessimisticLocking",
            "setUpdateStrategyToUpdateWithNoLocking",
            "forgetAllLocks",
            "invalidateAllObjects"});
    }

    public void setUpdateStrategyToUpdateWithOptimisticLocking() {
        dc().setUpdateStrategy(EODatabaseContext.UpdateWithOptimisticLocking);
    }

    public void setUpdateStrategyToUpdateWithPessimisticLocking() {
        dc().setUpdateStrategy(EODatabaseContext.UpdateWithPessimisticLocking);
    }

    public void setUpdateStrategyToUpdateWithNoLocking() {
        dc().setUpdateStrategy(EODatabaseContext.UpdateWithNoLocking);
    }

}
