//
// Main.java: Class file for WO Component 'Main'
// Project EOInspector
//
// Created by john on Tue Jul 20 2004
//

import java.util.*;
import groovy.lang.*;
import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.webobjects.eocontrol.*;
import com.webobjects.eoaccess.*;

public class Main extends ObjectBrowser {
    public Inspector inspector;
    public String selectedClassName;
    public NSArray classNames;
    public String className;
    public String object;
    public String script;
    public String errorLog;

    public Main(WOContext context) {
        super(context);
        ObjectBrowser.setDefaultBrowser(this);
		workspace = (WorkspacePage)pageWithName("WorkspacePage");
        classNames = new NSArray(new Object[] {
            "NSMutableArray", "NSMutableDictionary", "EOEditingContext",
            "EOObjectStoreCoordinator"});
        createCoordinators();
    }

    public WOComponent testSaveChanges() {
        session().defaultEditingContext().setDelegate(DelegateLogger.defaultLogger());
        EOFetchSpecification fs = new EOFetchSpecification("Movie", null, null);
        fs.setFetchLimit(1);
        NSArray objects = session().defaultEditingContext().objectsWithFetchSpecification(fs);

        Enumeration e = EOObjectStoreCoordinator.defaultCoordinator().cooperatingObjectStores().objectEnumerator();
        while (e.hasMoreElements()) {
            EODatabaseContext dbCxt = (EODatabaseContext)e.nextElement();
            dbCxt.setDelegate(DelegateLogger.defaultLogger());
            EOAdaptorContext adCxt = dbCxt.adaptorContext();
            adCxt.setDelegate(DelegateLogger.defaultLogger());
            adCxt.adaptor().setDelegate(DelegateLogger.defaultLogger());

            Enumeration adChlE = adCxt.channels().objectEnumerator();
            while (adChlE.hasMoreElements()) {
                EOAdaptorChannel adChl = (EOAdaptorChannel)adChlE.nextElement();
                adChl.setDelegate(DelegateLogger.defaultLogger());
            }
        }

        EOEnterpriseObject eo = (EOEnterpriseObject)objects.objectAtIndex(0);
        EOObserverCenter.addObserver(DelegateLogger.defaultLogger(), eo);

        if (eo.valueForKey("category") == null)
            eo.takeValueForKey("Action", "category");
        else if (eo.valueForKey("category").equals("Action"))
            eo.takeValueForKey("action", "category");
        else
            eo.takeValueForKey("Action", "category");
        session().defaultEditingContext().saveChanges();
        EOEditingContext ec = new EOEditingContext();
        objects = ec.objectsWithFetchSpecification(fs);
        object = (String)((EOEnterpriseObject)objects.objectAtIndex(0)).valueForKey("category");
        return null;
    }

    public WOComponent createCoordinators() {
        EOObjectStoreCoordinator osc1 = new EOObjectStoreCoordinator();
        EOObjectStoreCoordinator osc2 = new EOObjectStoreCoordinator();
        EOEditingContext ec1 = new EOEditingContext(osc1);
        ec1.setDelegate(DelegateLogger.defaultLogger());
        EOEditingContext ec2 = new EOEditingContext(osc2);
        ec2.setDelegate(DelegateLogger.defaultLogger());
        registerObject(osc1);
        registerObject(osc2);
        registerObject(ec1);
        registerObject(ec2);
        DelegateLogger.defaultLogger().removeAllLogs();
        return null;
    }

    public WOComponent addDelegateLogger() {
        registerObject(DelegateLogger.defaultLogger());
        return null;
    }

    public WOComponent removeAllInspectors() {
        ObjectBrowser.defaultBrowser().unregisterAllInspector();
        return null;
    }

    public String nameForInspector()
    {
        return nameForObject(inspector.object());
    }

    public WOComponent unregisterInspector()
    {
        unregisterInspector(inspector);
        return null;
    }

    public WOComponent addEditingContext()
    {
        registerObject(session().defaultEditingContext());
        return null;
    }

    public WOComponent createObject()
    {
        Object object = createObject(selectedClassName);
        if (object != null)
            registerObject(object);
        return null;
    }

    public Object createObject(String className) {
        Class classForName;
        Object object;
        String packageName;

        NSArray packageNames = new NSArray(new Object[]{
            "com.webobjects.foundation", "com.webobjects.appserver",
            "com.webobjects.eoaccess", "com.webobjects.eocontrol"});
        Enumeration en = packageNames.objectEnumerator();
        while (en.hasMoreElements()) {
            packageName = (String)en.nextElement();
            try {
                classForName = Class.forName(packageName + "." + className);
                return object = classForName.newInstance();
            } catch (ClassNotFoundException e) {
            } catch (InstantiationException e) {
            } catch (IllegalAccessException e) {
            }
        }

        return null;
    }

    public WOComponent addModelGroup()
    {
        registerObject(EOModelGroup.defaultGroup());
        return null;
    }

    public WorkspacePage workspacePage()
    {
        return workspace;
    }

    public WOComponent evaluate()
    {
		try {
			GroovyShell sh = workspace.shell();
			Closure cl = (Closure)sh.evaluate("cl = {" + script + "}");
			cl.call(this);
		} catch (Exception e) {
			errorLog = e.toString();
		}
        return null;
    }

}
