//
//  DictionaryInspector.java
//  EOInspector
//

import java.util.*;
import com.webobjects.foundation.*;
import com.webobjects.eocontrol.*;

public class NSDictionaryInspector extends Inspector {

	public String bindingBaseName() {
		return "dict";
	}
	
	public NSDictionary dict() {
		return (NSDictionary)object();
	}
	
    public NSArray allKeys() {
		NSMutableArray keys =
			new NSMutableArray(new Object[] {"allKeys", "allValues", "count",
				"description"});
		Enumeration e = ((NSDictionary)object).allKeys().objectEnumerator();
		while (e.hasMoreElements()) {
			keys.addObject(e.nextElement().toString());
		}
		return keys;
	}

    public NSArray allActions() {
		return new NSArray(new Object[]{"mutableClone"});
	}

	public Object valueForKey(String key) {
		if (key.equals("allKeys"))
			return dict().allKeys();

		try {
			return NSKeyValueCoding.DefaultImplementation.valueForKey(this, key);
		} catch (NSKeyValueCoding.UnknownKeyException e) {
			return dict().objectForKey(key);
		}
	}

	public NSArray allValues() {
		return dict().allValues();
	}

	public int count() {
		return dict().count();
	}

	public void mutableClone() {
		registerObject(dict().mutableClone());
	}
}
