//
//  NSMutableDictionaryInspector.java
//  EOInspector
//

import com.webobjects.foundation.*;
import com.webobjects.eocontrol.*;

public class NSMutableDictionaryInspector extends NSDictionaryInspector {

	public String bindingBaseName() {
		return "mdict";
	}
	
	public NSMutableDictionary mdict() {
		return (NSMutableDictionary)object();
	}

    public NSArray allActions() {
		return new NSArray(new Object[]{"immutableClone"});
	}

	public void takeValueForKey(Object value, String key) {
		if (mdict().objectForKey(key) == null) {
			throw new RuntimeException("Can't set value for '" + key +
				"', because the key is one of key of the object");
		} else {
			mdict().takeValueForKey(value, key);
		}
	}

	public void immutableClone() {
		registerObject(mdict().immutableClone());
	}
}
